t / test-lib.shon commit test-lib: set BASH_XTRACEFD automatically (d88785e)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39################################################################
  40# It appears that people try to run tests without building...
  41"$GIT_BUILD_DIR/git" >/dev/null
  42if test $? != 1
  43then
  44        echo >&2 'error: you do not seem to have built git yet.'
  45        exit 1
  46fi
  47
  48. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  49export PERL_PATH SHELL_PATH
  50
  51# if --tee was passed, write the output not only to the terminal, but
  52# additionally to the file test-results/$BASENAME.out, too.
  53case "$GIT_TEST_TEE_STARTED, $* " in
  54done,*)
  55        # do not redirect again
  56        ;;
  57*' --tee '*|*' --va'*)
  58        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  59        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  60        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  61         echo $? > $BASE.exit) | tee $BASE.out
  62        test "$(cat $BASE.exit)" = 0
  63        exit
  64        ;;
  65esac
  66
  67# For repeatability, reset the environment to known value.
  68# TERM is sanitized below, after saving color control sequences.
  69LANG=C
  70LC_ALL=C
  71PAGER=cat
  72TZ=UTC
  73export LANG LC_ALL PAGER TZ
  74EDITOR=:
  75# A call to "unset" with no arguments causes at least Solaris 10
  76# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  77# deriving from the command substitution clustered with the other
  78# ones.
  79unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  80        my @env = keys %ENV;
  81        my $ok = join("|", qw(
  82                TRACE
  83                DEBUG
  84                USE_LOOKUP
  85                TEST
  86                .*_TEST
  87                PROVE
  88                VALGRIND
  89                UNZIP
  90                PERF_
  91                CURL_VERBOSE
  92        ));
  93        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  94        print join("\n", @vars);
  95')
  96unset XDG_CONFIG_HOME
  97unset GITPERLLIB
  98GIT_AUTHOR_EMAIL=author@example.com
  99GIT_AUTHOR_NAME='A U Thor'
 100GIT_COMMITTER_EMAIL=committer@example.com
 101GIT_COMMITTER_NAME='C O Mitter'
 102GIT_MERGE_VERBOSITY=5
 103GIT_MERGE_AUTOEDIT=no
 104export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 105export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 106export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 107export EDITOR
 108
 109# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 110GIT_TRACE_BARE=1
 111export GIT_TRACE_BARE
 112
 113if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 114then
 115        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 116        export GIT_INDEX_VERSION
 117fi
 118
 119# Add libc MALLOC and MALLOC_PERTURB test
 120# only if we are not executing the test with valgrind
 121if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 122   test -n "$TEST_NO_MALLOC_CHECK"
 123then
 124        setup_malloc_check () {
 125                : nothing
 126        }
 127        teardown_malloc_check () {
 128                : nothing
 129        }
 130else
 131        setup_malloc_check () {
 132                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 133                export MALLOC_CHECK_ MALLOC_PERTURB_
 134        }
 135        teardown_malloc_check () {
 136                unset MALLOC_CHECK_ MALLOC_PERTURB_
 137        }
 138fi
 139
 140: ${ASAN_OPTIONS=detect_leaks=0}
 141export ASAN_OPTIONS
 142
 143# Protect ourselves from common misconfiguration to export
 144# CDPATH into the environment
 145unset CDPATH
 146
 147unset GREP_OPTIONS
 148unset UNZIP
 149
 150case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1511|2|true)
 152        GIT_TRACE=4
 153        ;;
 154esac
 155
 156# Convenience
 157#
 158# A regexp to match 5 and 40 hexdigits
 159_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 160_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 161
 162# Zero SHA-1
 163_z40=0000000000000000000000000000000000000000
 164
 165# Line feed
 166LF='
 167'
 168
 169# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 170# when case-folding filenames
 171u200c=$(printf '\342\200\214')
 172
 173export _x05 _x40 _z40 LF u200c
 174
 175# Each test should start with something like this, after copyright notices:
 176#
 177# test_description='Description of this test...
 178# This test checks if command xyzzy does the right thing...
 179# '
 180# . ./test-lib.sh
 181test "x$TERM" != "xdumb" && (
 182                test -t 1 &&
 183                tput bold >/dev/null 2>&1 &&
 184                tput setaf 1 >/dev/null 2>&1 &&
 185                tput sgr0 >/dev/null 2>&1
 186        ) &&
 187        color=t
 188
 189while test "$#" -ne 0
 190do
 191        case "$1" in
 192        -d|--d|--de|--deb|--debu|--debug)
 193                debug=t; shift ;;
 194        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 195                immediate=t; shift ;;
 196        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 197                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 198        -r)
 199                shift; test "$#" -ne 0 || {
 200                        echo 'error: -r requires an argument' >&2;
 201                        exit 1;
 202                }
 203                run_list=$1; shift ;;
 204        --run=*)
 205                run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
 206        -h|--h|--he|--hel|--help)
 207                help=t; shift ;;
 208        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 209                verbose=t; shift ;;
 210        --verbose-only=*)
 211                verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 212                shift ;;
 213        -q|--q|--qu|--qui|--quie|--quiet)
 214                # Ignore --quiet under a TAP::Harness. Saying how many tests
 215                # passed without the ok/not ok details is always an error.
 216                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 217        --with-dashes)
 218                with_dashes=t; shift ;;
 219        --no-color)
 220                color=; shift ;;
 221        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 222                valgrind=memcheck
 223                shift ;;
 224        --valgrind=*)
 225                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 226                shift ;;
 227        --valgrind-only=*)
 228                valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 229                shift ;;
 230        --tee)
 231                shift ;; # was handled already
 232        --root=*)
 233                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 234                shift ;;
 235        --chain-lint)
 236                GIT_TEST_CHAIN_LINT=1
 237                shift ;;
 238        --no-chain-lint)
 239                GIT_TEST_CHAIN_LINT=0
 240                shift ;;
 241        -x)
 242                trace=t
 243                verbose=t
 244                shift ;;
 245        *)
 246                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 247        esac
 248done
 249
 250if test -n "$valgrind_only"
 251then
 252        test -z "$valgrind" && valgrind=memcheck
 253        test -z "$verbose" && verbose_only="$valgrind_only"
 254elif test -n "$valgrind"
 255then
 256        verbose=t
 257fi
 258
 259if test -n "$color"
 260then
 261        # Save the color control sequences now rather than run tput
 262        # each time say_color() is called.  This is done for two
 263        # reasons:
 264        #   * TERM will be changed to dumb
 265        #   * HOME will be changed to a temporary directory and tput
 266        #     might need to read ~/.terminfo from the original HOME
 267        #     directory to get the control sequences
 268        # Note:  This approach assumes the control sequences don't end
 269        # in a newline for any terminal of interest (command
 270        # substitutions strip trailing newlines).  Given that most
 271        # (all?) terminals in common use are related to ECMA-48, this
 272        # shouldn't be a problem.
 273        say_color_error=$(tput bold; tput setaf 1) # bold red
 274        say_color_skip=$(tput setaf 4) # blue
 275        say_color_warn=$(tput setaf 3) # brown/yellow
 276        say_color_pass=$(tput setaf 2) # green
 277        say_color_info=$(tput setaf 6) # cyan
 278        say_color_reset=$(tput sgr0)
 279        say_color_="" # no formatting for normal text
 280        say_color () {
 281                test -z "$1" && test -n "$quiet" && return
 282                eval "say_color_color=\$say_color_$1"
 283                shift
 284                printf "%s\\n" "$say_color_color$*$say_color_reset"
 285        }
 286else
 287        say_color() {
 288                test -z "$1" && test -n "$quiet" && return
 289                shift
 290                printf "%s\n" "$*"
 291        }
 292fi
 293
 294TERM=dumb
 295export TERM
 296
 297error () {
 298        say_color error "error: $*"
 299        GIT_EXIT_OK=t
 300        exit 1
 301}
 302
 303say () {
 304        say_color info "$*"
 305}
 306
 307test "${test_description}" != "" ||
 308error "Test script did not set test_description."
 309
 310if test "$help" = "t"
 311then
 312        printf '%s\n' "$test_description"
 313        exit 0
 314fi
 315
 316exec 5>&1
 317exec 6<&0
 318if test "$verbose" = "t"
 319then
 320        exec 4>&2 3>&1
 321else
 322        exec 4>/dev/null 3>/dev/null
 323fi
 324
 325# Send any "-x" output directly to stderr to avoid polluting tests
 326# which capture stderr. We can do this unconditionally since it
 327# has no effect if tracing isn't turned on.
 328#
 329# Note that this sets up the trace fd as soon as we assign the variable, so it
 330# must come after the creation of descriptor 4 above. Likewise, we must never
 331# unset this, as it has the side effect of closing descriptor 4, which we
 332# use to show verbose tests to the user.
 333#
 334# Note also that we don't need or want to export it. The tracing is local to
 335# this shell, and we would not want to influence any shells we exec.
 336BASH_XTRACEFD=4
 337
 338test_failure=0
 339test_count=0
 340test_fixed=0
 341test_broken=0
 342test_success=0
 343
 344test_external_has_tap=0
 345
 346die () {
 347        code=$?
 348        if test -n "$GIT_EXIT_OK"
 349        then
 350                exit $code
 351        else
 352                echo >&5 "FATAL: Unexpected exit with code $code"
 353                exit 1
 354        fi
 355}
 356
 357GIT_EXIT_OK=
 358trap 'die' EXIT
 359trap 'exit $?' INT
 360
 361# The user-facing functions are loaded from a separate file so that
 362# test_perf subshells can have them too
 363. "$TEST_DIRECTORY/test-lib-functions.sh"
 364
 365# You are not expected to call test_ok_ and test_failure_ directly, use
 366# the test_expect_* functions instead.
 367
 368test_ok_ () {
 369        test_success=$(($test_success + 1))
 370        say_color "" "ok $test_count - $@"
 371}
 372
 373test_failure_ () {
 374        test_failure=$(($test_failure + 1))
 375        say_color error "not ok $test_count - $1"
 376        shift
 377        printf '%s\n' "$*" | sed -e 's/^/#      /'
 378        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 379}
 380
 381test_known_broken_ok_ () {
 382        test_fixed=$(($test_fixed+1))
 383        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 384}
 385
 386test_known_broken_failure_ () {
 387        test_broken=$(($test_broken+1))
 388        say_color warn "not ok $test_count - $@ # TODO known breakage"
 389}
 390
 391test_debug () {
 392        test "$debug" = "" || eval "$1"
 393}
 394
 395match_pattern_list () {
 396        arg="$1"
 397        shift
 398        test -z "$*" && return 1
 399        for pattern_
 400        do
 401                case "$arg" in
 402                $pattern_)
 403                        return 0
 404                esac
 405        done
 406        return 1
 407}
 408
 409match_test_selector_list () {
 410        title="$1"
 411        shift
 412        arg="$1"
 413        shift
 414        test -z "$1" && return 0
 415
 416        # Both commas and whitespace are accepted as separators.
 417        OLDIFS=$IFS
 418        IFS='   ,'
 419        set -- $1
 420        IFS=$OLDIFS
 421
 422        # If the first selector is negative we include by default.
 423        include=
 424        case "$1" in
 425                !*) include=t ;;
 426        esac
 427
 428        for selector
 429        do
 430                orig_selector=$selector
 431
 432                positive=t
 433                case "$selector" in
 434                        !*)
 435                                positive=
 436                                selector=${selector##?}
 437                                ;;
 438                esac
 439
 440                test -z "$selector" && continue
 441
 442                case "$selector" in
 443                        *-*)
 444                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 445                                then
 446                                        echo "error: $title: invalid non-numeric in range" \
 447                                                "start: '$orig_selector'" >&2
 448                                        exit 1
 449                                fi
 450                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 451                                then
 452                                        echo "error: $title: invalid non-numeric in range" \
 453                                                "end: '$orig_selector'" >&2
 454                                        exit 1
 455                                fi
 456                                ;;
 457                        *)
 458                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 459                                then
 460                                        echo "error: $title: invalid non-numeric in test" \
 461                                                "selector: '$orig_selector'" >&2
 462                                        exit 1
 463                                fi
 464                esac
 465
 466                # Short cut for "obvious" cases
 467                test -z "$include" && test -z "$positive" && continue
 468                test -n "$include" && test -n "$positive" && continue
 469
 470                case "$selector" in
 471                        -*)
 472                                if test $arg -le ${selector#-}
 473                                then
 474                                        include=$positive
 475                                fi
 476                                ;;
 477                        *-)
 478                                if test $arg -ge ${selector%-}
 479                                then
 480                                        include=$positive
 481                                fi
 482                                ;;
 483                        *-*)
 484                                if test ${selector%%-*} -le $arg \
 485                                        && test $arg -le ${selector#*-}
 486                                then
 487                                        include=$positive
 488                                fi
 489                                ;;
 490                        *)
 491                                if test $arg -eq $selector
 492                                then
 493                                        include=$positive
 494                                fi
 495                                ;;
 496                esac
 497        done
 498
 499        test -n "$include"
 500}
 501
 502maybe_teardown_verbose () {
 503        test -z "$verbose_only" && return
 504        exec 4>/dev/null 3>/dev/null
 505        verbose=
 506}
 507
 508last_verbose=t
 509maybe_setup_verbose () {
 510        test -z "$verbose_only" && return
 511        if match_pattern_list $test_count $verbose_only
 512        then
 513                exec 4>&2 3>&1
 514                # Emit a delimiting blank line when going from
 515                # non-verbose to verbose.  Within verbose mode the
 516                # delimiter is printed by test_expect_*.  The choice
 517                # of the initial $last_verbose is such that before
 518                # test 1, we do not print it.
 519                test -z "$last_verbose" && echo >&3 ""
 520                verbose=t
 521        else
 522                exec 4>/dev/null 3>/dev/null
 523                verbose=
 524        fi
 525        last_verbose=$verbose
 526}
 527
 528maybe_teardown_valgrind () {
 529        test -z "$GIT_VALGRIND" && return
 530        GIT_VALGRIND_ENABLED=
 531}
 532
 533maybe_setup_valgrind () {
 534        test -z "$GIT_VALGRIND" && return
 535        if test -z "$valgrind_only"
 536        then
 537                GIT_VALGRIND_ENABLED=t
 538                return
 539        fi
 540        GIT_VALGRIND_ENABLED=
 541        if match_pattern_list $test_count $valgrind_only
 542        then
 543                GIT_VALGRIND_ENABLED=t
 544        fi
 545}
 546
 547# This is a separate function because some tests use
 548# "return" to end a test_expect_success block early
 549# (and we want to make sure we run any cleanup like
 550# "set +x").
 551test_eval_inner_ () {
 552        # Do not add anything extra (including LF) after '$*'
 553        eval "
 554                test \"$trace\" = t && set -x
 555                $*"
 556}
 557
 558test_eval_ () {
 559        # We run this block with stderr redirected to avoid extra cruft
 560        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 561        # the shell from printing the "set +x" to turn it off (nor the saving
 562        # of $? before that). But we can make sure that the output goes to
 563        # /dev/null.
 564        #
 565        # The test itself is run with stderr put back to &4 (so either to
 566        # /dev/null, or to the original stderr if --verbose was used).
 567        {
 568                test_eval_inner_ "$@" </dev/null >&3 2>&4
 569                test_eval_ret_=$?
 570                if test "$trace" = t
 571                then
 572                        set +x
 573                        if test "$test_eval_ret_" != 0
 574                        then
 575                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 576                        fi
 577                fi
 578        } 2>/dev/null
 579        return $test_eval_ret_
 580}
 581
 582test_run_ () {
 583        test_cleanup=:
 584        expecting_failure=$2
 585
 586        if test "${GIT_TEST_CHAIN_LINT:-0}" != 0; then
 587                # 117 is magic because it is unlikely to match the exit
 588                # code of other programs
 589                test_eval_ "(exit 117) && $1"
 590                if test "$?" != 117; then
 591                        error "bug in the test script: broken &&-chain: $1"
 592                fi
 593        fi
 594
 595        setup_malloc_check
 596        test_eval_ "$1"
 597        eval_ret=$?
 598        teardown_malloc_check
 599
 600        if test -z "$immediate" || test $eval_ret = 0 ||
 601           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 602        then
 603                setup_malloc_check
 604                test_eval_ "$test_cleanup"
 605                teardown_malloc_check
 606        fi
 607        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 608        then
 609                echo ""
 610        fi
 611        return "$eval_ret"
 612}
 613
 614test_start_ () {
 615        test_count=$(($test_count+1))
 616        maybe_setup_verbose
 617        maybe_setup_valgrind
 618}
 619
 620test_finish_ () {
 621        echo >&3 ""
 622        maybe_teardown_valgrind
 623        maybe_teardown_verbose
 624}
 625
 626test_skip () {
 627        to_skip=
 628        skipped_reason=
 629        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 630        then
 631                to_skip=t
 632                skipped_reason="GIT_SKIP_TESTS"
 633        fi
 634        if test -z "$to_skip" && test -n "$test_prereq" &&
 635           ! test_have_prereq "$test_prereq"
 636        then
 637                to_skip=t
 638
 639                of_prereq=
 640                if test "$missing_prereq" != "$test_prereq"
 641                then
 642                        of_prereq=" of $test_prereq"
 643                fi
 644                skipped_reason="missing $missing_prereq${of_prereq}"
 645        fi
 646        if test -z "$to_skip" && test -n "$run_list" &&
 647                ! match_test_selector_list '--run' $test_count "$run_list"
 648        then
 649                to_skip=t
 650                skipped_reason="--run"
 651        fi
 652
 653        case "$to_skip" in
 654        t)
 655                say_color skip >&3 "skipping test: $@"
 656                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 657                : true
 658                ;;
 659        *)
 660                false
 661                ;;
 662        esac
 663}
 664
 665# stub; perf-lib overrides it
 666test_at_end_hook_ () {
 667        :
 668}
 669
 670test_done () {
 671        GIT_EXIT_OK=t
 672
 673        if test -z "$HARNESS_ACTIVE"
 674        then
 675                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 676                mkdir -p "$test_results_dir"
 677                base=${0##*/}
 678                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 679
 680                cat >>"$test_results_path" <<-EOF
 681                total $test_count
 682                success $test_success
 683                fixed $test_fixed
 684                broken $test_broken
 685                failed $test_failure
 686
 687                EOF
 688        fi
 689
 690        if test "$test_fixed" != 0
 691        then
 692                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 693        fi
 694        if test "$test_broken" != 0
 695        then
 696                say_color warn "# still have $test_broken known breakage(s)"
 697        fi
 698        if test "$test_broken" != 0 || test "$test_fixed" != 0
 699        then
 700                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 701                msg="remaining $test_remaining test(s)"
 702        else
 703                test_remaining=$test_count
 704                msg="$test_count test(s)"
 705        fi
 706        case "$test_failure" in
 707        0)
 708                # Maybe print SKIP message
 709                if test -n "$skip_all" && test $test_count -gt 0
 710                then
 711                        error "Can't use skip_all after running some tests"
 712                fi
 713                test -z "$skip_all" || skip_all=" # SKIP $skip_all"
 714
 715                if test $test_external_has_tap -eq 0
 716                then
 717                        if test $test_remaining -gt 0
 718                        then
 719                                say_color pass "# passed all $msg"
 720                        fi
 721                        say "1..$test_count$skip_all"
 722                fi
 723
 724                test -d "$remove_trash" &&
 725                cd "$(dirname "$remove_trash")" &&
 726                rm -rf "$(basename "$remove_trash")"
 727
 728                test_at_end_hook_
 729
 730                exit 0 ;;
 731
 732        *)
 733                if test $test_external_has_tap -eq 0
 734                then
 735                        say_color error "# failed $test_failure among $msg"
 736                        say "1..$test_count"
 737                fi
 738
 739                exit 1 ;;
 740
 741        esac
 742}
 743
 744if test -n "$valgrind"
 745then
 746        make_symlink () {
 747                test -h "$2" &&
 748                test "$1" = "$(readlink "$2")" || {
 749                        # be super paranoid
 750                        if mkdir "$2".lock
 751                        then
 752                                rm -f "$2" &&
 753                                ln -s "$1" "$2" &&
 754                                rm -r "$2".lock
 755                        else
 756                                while test -d "$2".lock
 757                                do
 758                                        say "Waiting for lock on $2."
 759                                        sleep 1
 760                                done
 761                        fi
 762                }
 763        }
 764
 765        make_valgrind_symlink () {
 766                # handle only executables, unless they are shell libraries that
 767                # need to be in the exec-path.
 768                test -x "$1" ||
 769                test "# " = "$(head -c 2 <"$1")" ||
 770                return;
 771
 772                base=$(basename "$1")
 773                symlink_target=$GIT_BUILD_DIR/$base
 774                # do not override scripts
 775                if test -x "$symlink_target" &&
 776                    test ! -d "$symlink_target" &&
 777                    test "#!" != "$(head -c 2 < "$symlink_target")"
 778                then
 779                        symlink_target=../valgrind.sh
 780                fi
 781                case "$base" in
 782                *.sh|*.perl)
 783                        symlink_target=../unprocessed-script
 784                esac
 785                # create the link, or replace it if it is out of date
 786                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 787        }
 788
 789        # override all git executables in TEST_DIRECTORY/..
 790        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 791        mkdir -p "$GIT_VALGRIND"/bin
 792        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 793        do
 794                make_valgrind_symlink $file
 795        done
 796        # special-case the mergetools loadables
 797        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 798        OLDIFS=$IFS
 799        IFS=:
 800        for path in $PATH
 801        do
 802                ls "$path"/git-* 2> /dev/null |
 803                while read file
 804                do
 805                        make_valgrind_symlink "$file"
 806                done
 807        done
 808        IFS=$OLDIFS
 809        PATH=$GIT_VALGRIND/bin:$PATH
 810        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 811        export GIT_VALGRIND
 812        GIT_VALGRIND_MODE="$valgrind"
 813        export GIT_VALGRIND_MODE
 814        GIT_VALGRIND_ENABLED=t
 815        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 816        export GIT_VALGRIND_ENABLED
 817elif test -n "$GIT_TEST_INSTALLED"
 818then
 819        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 820        error "Cannot run git from $GIT_TEST_INSTALLED."
 821        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 822        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 823else # normal case, use ../bin-wrappers only unless $with_dashes:
 824        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 825        if ! test -x "$git_bin_dir/git"
 826        then
 827                if test -z "$with_dashes"
 828                then
 829                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 830                fi
 831                with_dashes=t
 832        fi
 833        PATH="$git_bin_dir:$PATH"
 834        GIT_EXEC_PATH=$GIT_BUILD_DIR
 835        if test -n "$with_dashes"
 836        then
 837                PATH="$GIT_BUILD_DIR:$PATH"
 838        fi
 839fi
 840GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 841GIT_CONFIG_NOSYSTEM=1
 842GIT_ATTR_NOSYSTEM=1
 843export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 844
 845if test -z "$GIT_TEST_CMP"
 846then
 847        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 848        then
 849                GIT_TEST_CMP="$DIFF -c"
 850        else
 851                GIT_TEST_CMP="$DIFF -u"
 852        fi
 853fi
 854
 855GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 856export GITPERLLIB
 857test -d "$GIT_BUILD_DIR"/templates/blt || {
 858        error "You haven't built things yet, have you?"
 859}
 860
 861if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 862then
 863        echo >&2 'You need to build test-chmtime:'
 864        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 865        exit 1
 866fi
 867
 868# Test repository
 869TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 870test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 871case "$TRASH_DIRECTORY" in
 872/*) ;; # absolute path is good
 873 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 874esac
 875test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 876rm -fr "$TRASH_DIRECTORY" || {
 877        GIT_EXIT_OK=t
 878        echo >&5 "FATAL: Cannot prepare test area"
 879        exit 1
 880}
 881
 882HOME="$TRASH_DIRECTORY"
 883GNUPGHOME="$HOME/gnupg-home-not-used"
 884export HOME GNUPGHOME
 885
 886if test -z "$TEST_NO_CREATE_REPO"
 887then
 888        test_create_repo "$TRASH_DIRECTORY"
 889else
 890        mkdir -p "$TRASH_DIRECTORY"
 891fi
 892# Use -P to resolve symlinks in our working directory so that the cwd
 893# in subprocesses like git equals our $PWD (for pathname comparisons).
 894cd -P "$TRASH_DIRECTORY" || exit 1
 895
 896this_test=${0##*/}
 897this_test=${this_test%%-*}
 898if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 899then
 900        say_color info >&3 "skipping test $this_test altogether"
 901        skip_all="skip all tests in $this_test"
 902        test_done
 903fi
 904
 905# Provide an implementation of the 'yes' utility
 906yes () {
 907        if test $# = 0
 908        then
 909                y=y
 910        else
 911                y="$*"
 912        fi
 913
 914        while echo "$y"
 915        do
 916                :
 917        done
 918}
 919
 920# Fix some commands on Windows
 921case $(uname -s) in
 922*MINGW*)
 923        # Windows has its own (incompatible) sort and find
 924        sort () {
 925                /usr/bin/sort "$@"
 926        }
 927        find () {
 928                /usr/bin/find "$@"
 929        }
 930        sum () {
 931                md5sum "$@"
 932        }
 933        # git sees Windows-style pwd
 934        pwd () {
 935                builtin pwd -W
 936        }
 937        # no POSIX permissions
 938        # backslashes in pathspec are converted to '/'
 939        # exec does not inherit the PID
 940        test_set_prereq MINGW
 941        test_set_prereq NATIVE_CRLF
 942        test_set_prereq SED_STRIPS_CR
 943        test_set_prereq GREP_STRIPS_CR
 944        GIT_TEST_CMP=mingw_test_cmp
 945        ;;
 946*CYGWIN*)
 947        test_set_prereq POSIXPERM
 948        test_set_prereq EXECKEEPSPID
 949        test_set_prereq CYGWIN
 950        test_set_prereq SED_STRIPS_CR
 951        test_set_prereq GREP_STRIPS_CR
 952        ;;
 953*)
 954        test_set_prereq POSIXPERM
 955        test_set_prereq BSLASHPSPEC
 956        test_set_prereq EXECKEEPSPID
 957        ;;
 958esac
 959
 960( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 961test -z "$NO_PERL" && test_set_prereq PERL
 962test -z "$NO_PYTHON" && test_set_prereq PYTHON
 963test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 964test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 965
 966# Can we rely on git's output in the C locale?
 967if test -n "$GETTEXT_POISON"
 968then
 969        GIT_GETTEXT_POISON=YesPlease
 970        export GIT_GETTEXT_POISON
 971        test_set_prereq GETTEXT_POISON
 972else
 973        test_set_prereq C_LOCALE_OUTPUT
 974fi
 975
 976# Use this instead of test_cmp to compare files that contain expected and
 977# actual output from git commands that can be translated.  When running
 978# under GETTEXT_POISON this pretends that the command produced expected
 979# results.
 980test_i18ncmp () {
 981        test -n "$GETTEXT_POISON" || test_cmp "$@"
 982}
 983
 984# Use this instead of "grep expected-string actual" to see if the
 985# output from a git command that can be translated either contains an
 986# expected string, or does not contain an unwanted one.  When running
 987# under GETTEXT_POISON this pretends that the command produced expected
 988# results.
 989test_i18ngrep () {
 990        if test -n "$GETTEXT_POISON"
 991        then
 992            : # pretend success
 993        elif test "x!" = "x$1"
 994        then
 995                shift
 996                ! grep "$@"
 997        else
 998                grep "$@"
 999        fi
1000}
1001
1002test_lazy_prereq PIPE '
1003        # test whether the filesystem supports FIFOs
1004        case $(uname -s) in
1005        CYGWIN*)
1006                false
1007                ;;
1008        *)
1009                rm -f testfifo && mkfifo testfifo
1010                ;;
1011        esac
1012'
1013
1014test_lazy_prereq SYMLINKS '
1015        # test whether the filesystem supports symbolic links
1016        ln -s x y && test -h y
1017'
1018
1019test_lazy_prereq FILEMODE '
1020        test "$(git config --bool core.filemode)" = true
1021'
1022
1023test_lazy_prereq CASE_INSENSITIVE_FS '
1024        echo good >CamelCase &&
1025        echo bad >camelcase &&
1026        test "$(cat CamelCase)" != good
1027'
1028
1029test_lazy_prereq UTF8_NFD_TO_NFC '
1030        # check whether FS converts nfd unicode to nfc
1031        auml=$(printf "\303\244")
1032        aumlcdiar=$(printf "\141\314\210")
1033        >"$auml" &&
1034        case "$(echo *)" in
1035        "$aumlcdiar")
1036                true ;;
1037        *)
1038                false ;;
1039        esac
1040'
1041
1042test_lazy_prereq AUTOIDENT '
1043        sane_unset GIT_AUTHOR_NAME &&
1044        sane_unset GIT_AUTHOR_EMAIL &&
1045        git var GIT_AUTHOR_IDENT
1046'
1047
1048test_lazy_prereq EXPENSIVE '
1049        test -n "$GIT_TEST_LONG"
1050'
1051
1052test_lazy_prereq USR_BIN_TIME '
1053        test -x /usr/bin/time
1054'
1055
1056test_lazy_prereq NOT_ROOT '
1057        uid=$(id -u) &&
1058        test "$uid" != 0
1059'
1060
1061# On a filesystem that lacks SANITY, a file can be deleted even if
1062# the containing directory doesn't have write permissions, or a file
1063# can be accessed even if the containing directory doesn't have read
1064# or execute permissions, causing our tests that validate that Git
1065# works sensibly in such situations.
1066test_lazy_prereq SANITY '
1067        mkdir SANETESTD.1 SANETESTD.2 &&
1068
1069        chmod +w SANETESTD.1 SANETESTD.2 &&
1070        >SANETESTD.1/x 2>SANETESTD.2/x &&
1071        chmod -w SANETESTD.1 &&
1072        chmod -rx SANETESTD.2 ||
1073        error "bug in test sript: cannot prepare SANETESTD"
1074
1075        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1076        status=$?
1077
1078        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1079        rm -rf SANETESTD.1 SANETESTD.2 ||
1080        error "bug in test sript: cannot clean SANETESTD"
1081        return $status
1082'
1083
1084GIT_UNZIP=${GIT_UNZIP:-unzip}
1085test_lazy_prereq UNZIP '
1086        "$GIT_UNZIP" -v
1087        test $? -ne 127
1088'
1089
1090run_with_limited_cmdline () {
1091        (ulimit -s 128 && "$@")
1092}
1093
1094test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'